#include <dir.h>
#include <dos.h>
#include <string.h>
#include <conio.h>
#ifdef __GNUC__
#include <sys/nearptr.h>
#include <sys/stat.h>
#endif
#include "dirc.h"

int GetNoFiles(char *mask,int attrib)
{
   struct ffblk ffblk;
   int done,count = 0;
   done = findfirst(mask,&ffblk,attrib);
   while (!done)
   {
      count++;
      done = findnext(&ffblk);
   }
   return count;
}

int GetNoDisks(void)
{  int i,max,d1,d,count=0;
   d1 = getdisk();
   max = setdisk(d1);
   for(i=0;i<max;i++)
   { setdisk(i);
     d = getdisk();
     if(d == i)count++;
   }
   setdisk(d1);
   return count;

}


int DirFile(char *name)
{
   struct ffblk ffblk;
   int done;
 _dos_getfileattr(name,&done);
 if((done & _A_SUBDIR))return ISDIR;
return ISFILE;
}


int CheckDiskReady(int drive)
// Returns 0 on success; drive: default=0,a=1 etc
{
 struct diskfree_t dt;
 int i;
 i = _dos_getdiskfree(drive,&dt);
return i;
}

dialog *MakeDirDialog(dialog *d,int num,int numf,int numd)
{
int i,j;
struct ffblk ffblk;
int done,count = 0;

done = findfirst("*.*",&ffblk,FA_DIREC);
for(i=0;i<numf;i++)
  {
    for(j=0;j<16;j++)d->data[i][j] = 0;
    strcpy(d->data[i],ffblk.ff_name);
    if((j=DirFile(d->data[i])) == ISFILE)
      { strlwr(d->data[i]);
	d->flag[i] = ISFILE; }
    else d->flag[i] = ISDIR;
    done = findnext(&ffblk);
  }

for(i=numf;i<num;i++)
 {
  for(j=0;j<16;j++)d->data[i][j] = 0;
  d->data[i][0] = (i-numf) + 65;
  d->data[i][1] = 58;
  d->flag[i] = ISDRIVE;
 }

d->Xmax = 16;
d->Ymax = num;
d->Xpos = 0;
d->Ypos = 0;
return d;
}


void DisplayFileInfo(short *TextVid,char *path)
{
struct stat s;
char str[6];
menu m;
m.x1 = 38;m.y1 = 0;m.x2 = 79;m.y2 = 10;
m.colour = 4;m.SelPos =0;
memset(str,0,6);

DrawMenu(TextVid,&m);

if(patmat(path,"*:*"))
    {
     TextOut(TextVid,&m,"DRIVE	  ",12,0,1,9);
     TextOut(TextVid,&m,".........",12,0,2,9);
     TextOut(TextVid,&m,"......",12,0,3,6); }

else {
stat(path,&s);
if(S_ISDIR(s.st_mode))
  {
   TextOut(TextVid,&m,"DIRECTORY",12,0,1,9);
   TextOut(TextVid,&m,"SUBDIRS: ",12,0,2,9);
   TextOut(TextVid,&m,itoa((int)s.st_nlink-2,str,10),12,0,3,6);
  }

else
       {
       TextOut(TextVid,&m,"FILE     ",12,0,1,9);
       TextOut(TextVid,&m,"SIZE:    ",12,0,2,9);
       TextOut(TextVid,&m,itoa((int)s.st_size,str,10),12,0,3,6); }
    }

   TextOut(TextVid,&m,"DOS SHELL",11,0,5,9);
   TextOut(TextVid,&m,"ELLIOTT OTI",11,0,6,11);
   TextOut(TextVid,&m,"CHRISTMAS EVE 1996",11,0,7,18);
   TextOut(TextVid,&m,"THNX 2 DJGPP & MIKMOD",10,0,8,21);

}


char *FileSelector(short *TextVid)
{
int i;
menu m;
dialog d;
int key=0;
char command[120];
int num,numf,numd;


numf =	GetNoFiles("*.*",FA_DIREC);
numd =	GetNoDisks();
num = numf+numd;
d.data = (char **)malloc(num*sizeof(char *));
d.flag =  (int *)malloc(num*sizeof(int));
if(!d.data)return NULL;
if(!d.flag)return NULL;

for(i=0;i<numf;i++)
  {
    d.data[i] = (char *)malloc(16);
    if(!d.data[i])return NULL; }

for(i=numf;i<num;i++)
 {
  d.data[i] = (char *)malloc(16);
  if(!d.data[i])return NULL; }

m.x1 = 0; m.y1 = 0;m.x2 = 18;m.y2 = 24;m.colour = 4;m.SelPos = 1;
m.OldSelPos = -5;
HideCursor();
MakeDirDialog(&d,num,numf,numd);
DrawMenu(TextVid,&m);
WriteDialog(TextVid,&m,&d);
DrawSelPos(TextVid,&m);

while(1)
{
key = getch();
switch(key)
   {
   case KEYUP:
     {
     if(m.SelPos == 1)
     if(d.Ypos >0)d.Ypos--;
     if(m.SelPos>1)
       { m.OldSelPos = m.SelPos; m.SelPos--;
       DrawSelPos(TextVid,&m);
	}
     break;
     }
   case KEYDOWN:
     {
     if(m.SelPos == m.y2-1)
     if(d.Ypos < d.Ymax - 23)d.Ypos++;
     if(m.SelPos < lesser(m.y2 - 1,d.Ymax))
	{m.OldSelPos = m.SelPos;m.SelPos++;
	 DrawSelPos(TextVid,&m);
	 }
     break;
     }
   case ENTER:
     return d.data[d.Ypos+m.SelPos-1];

   case HOME:
    {m.SelPos = 1; d.Ypos = 0;break;}

   case END:
    {
     if(d.Ymax > 23)
     d.Ypos = d.Ymax - 23;
     m.SelPos = lesser(23,d.Ymax-d.Ypos);
     break;
    }

   case PGUP:
     {
      if((d.Ypos == (d.Ymax - 23)) && (m.SelPos == 23))
	m.SelPos = 1;
      else {
      if(d.Ypos > 23)d.Ypos -= 23;
      else d.Ypos = 0;
      m.SelPos = 1;  }
      break;
     }

   case PGDOWN:
    { if(d.Ypos < d.Ymax - 46)d.Ypos += 23;
      else if(d.Ypos < d.Ymax - 23)d.Ypos += (d.Ymax - d.Ypos - 23);
      m.SelPos = lesser(d.Ymax,23);
    break;
    }
    case F1:  ShowHelp(TextVid);
	      DrawMenu(TextVid,&m);
	      break;

    case F2:  _setcursortype(_NORMALCURSOR);
	      EEmain(d.data[d.Ypos+m.SelPos-1]);
	      ClearScreen(TextVid);
	      _setcursortype(_NOCURSOR);
	      DrawMenu(TextVid,&m);
	      break;

    case F3: _setcursortype(_SOLIDCURSOR);
	      GetUserCommand(TextVid,command);
	      ClearScreen(TextVid);
	      for(i=0;i<120;i++)
	      if(command[i])
	      {
	      system(command);
	      ClearScreen(TextVid);
	      _setcursortype(_NOCURSOR);
	      DrawMenu(TextVid,&m);
	      break;}
	      DrawMenu(TextVid,&m);
	      _setcursortype(_NOCURSOR);
	      break;
    case ESC: return NULL;

  }



   WriteDialog(TextVid,&m,&d);
   DrawSelPos(TextVid,&m);
   DisplayFileInfo(TextVid,d.data[d.Ypos+m.SelPos-1]);
  }
  return NULL;
 }


int patmat(char *raw,char *pat)
{  int	i, slraw;

   if ((*pat == '\0') && (*raw == '\0'))    /*	if it is end of both  */
     return( 1 ) ;			    /*	strings,then match    */
   if (*pat == '\0')			    /*	if it is end of only  */
     return( 0 ) ;			    /*	pat tehn mismatch     */
   if (*pat == '*')			    /* if pattern is a '*'    */
    { if (*(pat+1) == '\0')		    /*	  if it is end of pat */
     return( 1 ) ;			/*    then match	  */
      for(i=0,slraw=strlen(raw);i<=slraw;i++)/*    else hunt for match*/
    if ((*(raw+i) == *(pat+1)) ||	/*	   or wild card   */
	(*(pat+1) == '?'))
     if (patmat(raw+i+1,pat+2) == 1)	/*	if found,match	  */
	  return( 1 ) ; 		/*	  rest of pat	  */
    }
   else
    { if (*raw == '\0') 		    /*	if end of raw then    */
     return( 0 ) ;			/*     mismatch 	  */
      if ((*pat == '?') || (*pat == *raw))  /*	if chars match then   */
    if (patmat(raw+1,pat+1) == 1)	/*  try & match rest of it*/
       return( 1 ) ;
    }
   return( 0 ) ;			    /*	no match found	      */
}
