#include <dos.h>
#include "dirc.h"

// ---------------------------------------------------------------

void Box(short *TextVid,int x1,int y1,int x2,int y2,short int ch)
{
short int *Scr;
int i,j;

// error checking
if( (x1 < 0) || (x1 >= 80) ||
    (x2 < 0) || (x2 >= 80) ||
    (y1 < 0) || (y1 >= 25) ||
    (y2 < 0) || (y2 >= 25) )return;


// Top line
Scr = TextVid +  TEXTWIDTH*y1 + x1;
for(i=0;i < x2-x1;i++)
 *(Scr + i) = (TOP1 + (ch << 8));
// Bottom line
Scr = TextVid +  TEXTWIDTH*y2 + x1;
for(i=0;i < x2-x1;i++)
 *(Scr + i) = (TOP1+ (ch << 8));

// Left line
Scr = TextVid +  TEXTWIDTH*y1 + x1;
for(i=y1;i <= y2;i++,Scr+=TEXTWIDTH)
 *(Scr) = (SIDE1+ (ch << 8));
// Right line
Scr = TextVid +  TEXTWIDTH*y1 + x2;
for(i=y1;i <= y2;i++,Scr+=TEXTWIDTH)
 *(Scr) = (SIDE1+ (ch << 8));

//Put the corners:

*( TextVid +  TEXTWIDTH*y1 + x1) = TLC1+ (ch << 8);
*( TextVid +  TEXTWIDTH*y1 + x2) = TRC1+ (ch << 8);
*( TextVid +  TEXTWIDTH*y2 + x1) = BLC1+ (ch << 8);
*( TextVid +  TEXTWIDTH*y2 + x2) = BRC1+ (ch << 8);

}

// -----------------------------------------------------------------

void DrawMenu(short *TextVid,menu *m)
{
int i,j,k;
int Scr;
// Draw box
Box(TextVid,m->x1,m->y1,m->x2,m->y2,m->colour);
// Draw hilite
//if( (m->SelPos < 0) ||
//    (m->SelPos > m->y2-m->y1) )return;
//Scr = TEXTWIDTH*(m->y1+m->SelPos) + m->x1 + 1;
//for(i=0;i< ((m->x2)-(m->x1));i++)TextVid[Scr + i] += (128 << 8);
}

// ------------------------------------------------------------------

void ClearMenu(short *TextVid, menu *m)
{
int i,j;
short *Scr;
for(i=0;i<m->y2-m->y1-1;i++)
  {
  Scr = TextVid + TEXTWIDTH*(m->y1  + i) + m->x1 + 1;
  for(j=0;j<m->x2-m->x1;j++,Scr++)
     *Scr = 0x0000;
  }
}

// -------------------------------------------------------------------

void DrawSelPos(short *TextVid,menu *m)
{
int i,j,k;
int Scr;
if( (m->SelPos < 0) ||
    (m->SelPos > m->y2-m->y1) )return;

//Scr = TEXTWIDTH*(m->y1 + m->OldSelPos) + m->x1 + 1;
//if(m->OldSelPos > 0)
//for(i=0;i< ((m->x2)-(m->x1));i++)TextVid[Scr + i] -= (128 << 8);
Scr = TEXTWIDTH*(m->y1 + m->SelPos) + m->x1 + 1;
for(i=0;i< ((m->x2)-(m->x1)-2);i++)TextVid[Scr + i] += (128 << 8);
}

// -------------------------------------------------------------------

void TextOut(short *TextVid,menu *m,char *txt,int col,
		   int t_xpos,int ypos,int txtlen)
{
int i;
short *Scr = TextVid + TEXTWIDTH*(m->y1+ypos) + m->x1+1;
for(i=t_xpos;i<lesser(txtlen,t_xpos+(m->x2-m->x1)-1);i++,Scr++)
	  *Scr = (((short)txt[i]) + (col<< 8));
}

// -------------------------------------------------------------------

void WriteDialog(short *TextVid,menu *m,dialog *d)
{
int i;
for(i=d->Ypos;i < lesser( d->Ymax ,d->Ypos + m->y2 - m->y1 - 1);i++)
 TextOut(TextVid,m,d->data[i],d->flag[i],d->Xpos,i-d->Ypos+1,d->Xmax);
}

// ---------------------------------------------------------------------

void HideCursor()
{
union REGS r;
   r.h.cl=7;
   r.h.ch=32;
   r.h.ah=1;
int86(0x10,&r,&r);
}

// ---------------------------------------------------------------------

void ClearScreen(short *TextVid)
{
int i;
for(i=0;i<80*25;i++)TextVid[i] = 0x0000;
}
